package de.fish.tabacha;

import de.fish.tabacha.Thing;


/** etwas, was ein Thing tun kann oder was mit einem Thing getan werden kann.
	Oeffentliche Aktionen sind solche, die mit einem Thing getan werden koennen;
		die sozusagen ein Thing anderen anbietet.
		Die moeglichen oeffentlichen Aktionen erfaehrt man mit
		Thing.getOeffentlicheAktionen.
		Beispiel: Eine Kiste bietet die oeffentliche AbstractAction "oeffne mich" an.
		Anderer Name: passive AbstractAction

	Private Aktionen sind solche, die nur die AbstractSoul eines Dings initiieren kann.
		Alle moeglichen privaten und oeffentlichen Aktionen werden der AbstractSoul
		zugeschickt (AbstractSoul.empfangeAktionen).
		Beispiel: Der Narr bietet seiner AbstractSoul u.a. die AbstractAction "gehe Nord" an.
		Anderer Name: aktive AbstractAction

	@author $Author: sva00-michael $
	@version $Revision: 1.2 $

      	@see de.fish.tabacha.Thing#getOeffentlicheAktionen
       	@see de.fish.tabacha.AbstractSoul#empfangeAktionen
*/
public abstract class AbstractAction
{


  /** Konstruktor */
  public abstract void AbstractAction();

  /** Gibt eine Beschreibung zu einen Befehl */
  public abstract String getName();

  /** Gibt eine Beschreibung zu einen Befehl */
  public abstract String getDescription();

  /** start the action.
   *  */
  public abstract void start();

  /** start the action.
   * @param doer The thing who does the action */
  public abstract void start(Thing doer);

  /** start the action.
   * @param doer The thing who does the action
   * @param tool a tool (axe, key) for doing the action*/
  public abstract void start(Thing doer, Thing tool);
}
