package de.fish.tabacha;


/** holds things and knows their coordinate and surrounding in this
 * space.
 */
public abstract class AbstractSpace
{
  /** returns surrounding if thing has appropriate sense.
   *
   */
  public abstract AbstractSurrounding getSurrounding(AbstractSense sen, Thing thi);

  /** get coordinate of thing.
   * returns null if Thing is not in this space.
   * @param thi the thing
   */
  public abstract AbstractCoordinate getCoordinate(Thing thi);

  /** Get all things on a Coordinate. */
  public abstract Thing[] getThings (AbstractCoordinate coo);

  /** e.g. if a thing changes position the space gets
   * an event and has to tell all concerned surroundings
    */
  public abstract void receiveThingEvent();

}
