package de.fish.tabacha;
/** AbstractSurrounding enthaelt/beobachtet eine feste Anzahl von Dingen.
    Es gibt z.B. Seh- oder Hoerumgebung, Explosionsumgebung. <p>

    Umgebungen werden von AbstractSpace erstellt. <br>
    Umgebungen sind an ein Thing gebunden.<br>
    Dieses Thing wird Master genannt.<br>
    Eine AbstractSurrounding aendert sich, wenn sich der Master bewegt.<br>
    Eine AbstractSurrounding hat zum feststellen der Dinge, die sie
    beobachtet einen Algorithmus: berechneUmgebung
    (z.B. bei Schachbrettseeumgebung der Algorithmus
    zum 9*9 Felder beobachten) <p>

  <PRE>
    Es gibt zwei Verwendungsmoeglichkeiten fuer AbstractSurrounding:
    1. Die AbstractSurrounding bekommt ein Ereignis fuer den Master.
    (Bsp.: Jemand legt einen Apfel ab, ein Kueken schluepft aus Ei.)
    2. Die AbstractSurrounding schickt Ereignisse, die vom Master ausgehen.
    (Bsp.: Die Bombe (Master) explodiert und fuegt der AbstractSurrounding
     Schaden zu).
     Das heisst, eine AbstractSurrounding beobachtet immer ihren Master und
     der Master beobachtet immer seine Umgebungen.
    Wenn ein Thing nach Norden geht benachrichtigt es seine AbstractSurrounding,
    diese aendert dann die von ihr beobachteten Bilder.
    Aendert das Thing durch seine Bewegung eine AbstractSurrounding benachrichtigt
    diese ihren Master.   <p>

    perverser Spezialfall: Die Kristallkugel, in der ich das sehe,
    was der schwarzen Ritter sieht:
    Der Master ist der Ritter, ich bin der Beobachter der AbstractSurrounding
    des Ritters. Wenn der Ritter blind ist, sehe auch ich nichts.

   XXX Das ist mir alles zu komplex.
   </PRE>


 <P>
  $Id: AbstractSurrounding.java,v 1.1 2002/02/09 22:28:15 sva00-michael Exp $
  @author $Author: sva00-michael $
  @version $Revision: 1.1 $
*/

public abstract class AbstractSurrounding
{ 

  Thing master; // das Master-Thing
  AbstractSpace space;   // der AbstractSpace, fuer den die AbstractSurrounding gilt.
  AbstractSense sense;

  /** AbstractSurrounding eines Thing */
  public AbstractSurrounding(Thing masterDing, AbstractSpace masterRaum, AbstractSense einSinn)
    { 
      master=masterDing; 
      space=masterRaum;
      sense=einSinn;
    }


   /** hier kann sich ein Thing zur Beobachtung der AbstractSurrounding
      eintragen. Master ist immer Beobachter. */
  public abstract void addObserver(Thing aThing);

  

} 
