package de.fish.tabacha;

import java.util.Hashtable;

/** Objects which may have an AbstractSoul are
 *  Animatable. These may be AbstractThings or
 *  AbstractSouls (what else?)
 *
 */
public interface Animatable
{
  /** give Soul to object
   *  @param aSoul soul
   */
  public void animate(AbstractSoul aSoul);

  /** loescht die AbstractSoul dieses Objekts, d.h., setzt sie auf null. */
  public void kill();
       
  /** gibt die AbstractSoul zurueck.
    @return AbstractSoul
    */

  public AbstractSoul getSoul();

  /** dem Objekt wird befohlen, eine AbstractAction auszufuehren.
      Die AbstractSoul erhaelt die moeglichen Aktionen geschickt.
      (-> AbstractSoul.empfangeAktionen)
      @param eineAktion gibt die gewuenschte AbstractAction an.
  */

  public void doAction(AbstractAction anAction);

  /** gibt eine Liste der oeffentlichen Aktionen zurueck.
      Oeffentliche Aktionen, auch passive genannt, sind solche, die andere von aussen aufrufen koennen.
      Beispiel: Eine Kiste bietet die AbstractAction "oeffne mich" an.
  */
  public Hashtable getActions();

}
