package de.fish.tabacha;

import de.fish.tabacha.spaces.BirthSpace;

import de.fish.tabacha.spaces.AbstractSpace;
import java.util.HashMap;

/** Bob is the administrator of all things.
 *  There is only one Bob (singleton class).
 *  If you want to place a new thing in the world,
 *  like a jester (or else) you have to ask
 *  Bob.
 *  ? Does everything have an Id? Things, Surroundings, Souls, Senses?
 *  I think: things->yes, Surroundings->yes, Souls->yes, Senses-> No
 *
*/
public class Bob
{
  private static Bob bob;
  private BirthSpace birthSpace;
  private HashMap things;

  private Bob() {
    birthSpace = new BirthSpace();
    things = new HashMap(5,20);
  }

  public static Bob getBob() {
    if (bob==null) bob = new Bob();
    return bob;
  }

  /** register new thing in the world
   *  This will be placed in the BirthSpace.
  */
  public Oid register(Thing newThing) {
    birthSpace.addThing(newThing,null);
    things.put(OidFactory.getNewOid(),newThing);
  }
  /**
   * register a new thing and specify the space, where it should be placed.
   * If it cannot bew placed in the specified space, it will be placed in
   * BirthSpace.
   * @param newThing
   * @return
   */
   public Oid register(Thing newThing, AbstractSpace space, AbstractCoordinate position) {

    boolean possible = space.addThing(newThing,position);
    if (!possible) register(newThing);
    things.put(OidFactory.getNewOid(),newThing);
  }
  /**
   * removes a thing completely
   * @param thingId
   */
  public void remove(Oid thingId) {
    things.remove(thingId);
  }


  public Thing getThing(Oid thing) {
    things.get(thing);
  }

}
