package de.fish.tabacha;

/** The id for a thing.
    Needed for storing things and getting them back via id. There
    must not be persistent references to a thing. Getting things
    is always done via calling Bob.

    <P> $Id: Oid.java,v 1.3 2002/04/28 09:22:57 sva00-holger Exp $ </P>
    @author $Author: sva00-holger $
    @version $Revision: 1.3 $
    @see de.fish.tabacha.Bob
    @see de.fish.tabacha.OidFactory
*/
public final class Oid
{
  private long _id;

  /**
   * Constructor for getting a new Oid ??
   * @param lastID latest used ID
   */
  public Oid(Oid lastID) {
    if (lastID == null)
      _id = 0;
    else
      _id = lastID._id + 1;
  }

  /**
   * get Id
   * @return object id
   */
  public long getId() {
      return _id;
  }
    
}
