package de.fish.tabacha;

/** erzeugt neue Oids.
    Wird nur von Bob aus benutzt.
    Singleton

    <P> $Id: OidFabrik.java,v 1.1 2002/02/09 22:28:15 sva00-michael Exp $
    @author $Author: sva00-michael $
    @version $Revision: 1.1 $
*/
public class OidFabrik
{

  private final static OidFabrik _exemplar;

  private Oid naechsteZuVergebeneOid;

  private OidFabrik()
    { naechsteZuVergebeneOid = new Oid(null); }

  private Oid machNeueOid()
  {
    Oid dummy = naechsteZuVergebeneOid;
    naechsteZuVergebeneOid = new Oid(naechsteZuVergebeneOid);
    return dummy;
  }
    
  /** gibt eine neue, noch nicht vergebene Oid zurueck. */
  public static Oid gibNeueOid()
    { return _exemplar.machNeueOid(); }

}
