package de.fish.tabacha;

/** create new Ids.
    Is only used by Bob.
    Singleton

    <P> $Id: OidFactory.java,v 1.1 2002/04/28 09:28:23 sva00-holger Exp $
    @author $Author: sva00-holger $
    @version $Revision: 1.1 $
*/
public class OidFactory
{

  private final static OidFactory _instance;

  private Oid nextGettableOid;

  private OidFactory() {
    nextGettableOid = new Oid(null);
  }

  private Oid createNewOid() {
    Oid dummy = nextGettableOid;
    nextGettableOid = new Oid(nextGettableOid);
    return dummy;
  }
    
  /** gibt eine neue, noch nicht vergebene Oid zurueck. */
  public static Oid getNewOid() {
    if (_instance==null) {
      _instance=new OidFactory();
    }
    return _instance.createNewOid();
  }

}
