package de.fish.tabacha;

import java.util.Hashtable;


/**
 * mother of all things that exist in
 * the world. Everything may have a soul,
 * appearances, senses and surroundings.
 *
 * A thing that wants to appear in a certain
 * surrounding needs an appearance of the
 * same key. if it wants to sense something
 * in this surrounding it needs a sense of
 * the same key.
 <br> $Id: Thing.java,v 1.4 2002/05/09 17:27:02 sva00-holger Exp $
 @author ???
 @author $Author: sva00-holger $
 @version $Revision: 1.4 $
*/

public class Thing
       implements Attributable, Appearable, Animatable, Sensing, Surroundable
{
  protected String name="???";
  protected boolean _isLiving = false;
  protected Hashtable attributes = null;
  protected AbstractAppearance appearance = null;
  protected AbstractSoul soul = null;
  protected Hashtable senses = null; // is the sense not the key for a surrounding?
  protected Hashtable surroundings = null;

   public Thing(String nam) {
      this.name=nam;
   }
  /** creates a Thing with a soul
   * and a vector of attributes*/
  public Thing(String nam, AbstractAppearance app,
                       Hashtable att, AbstractSoul sou,
                       Hashtable sen, Hashtable sur) {
      this.name=nam;
      appearance=app;
      attributes=att;
      soul=sou;
      _isLiving = (soul!=null);
      senses=sen;
      surroundings=sur;
    }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public boolean isLiving() {
    return _isLiving;
  }

  public Hashtable getAttributes() {
      return attributes;
    }

  public void setAttributes(Hashtable attributes) {
    this.attributes = attributes;
  }

  public AbstractSoul getSoul() {
    return soul;
  }

  public void animate(AbstractSoul soul) {
    this.soul = soul;
    _isLiving = (soul!=null);
  }

  public Hashtable getSenses() {
    return senses;
  }

  public void setSenses(Hashtable sense) {
    this.senses = sense;
  }

  public void kill() {
  }

  public void doAction(AbstractAction anAction) {
    if (this.soul!=null)
      this.soul.getActions();
  }

  public Hashtable getActions() {
    Hashtable act=null;
    if (this.soul!=null)
      act=this.soul.getActions();
    return act;
  }


  public Hashtable getSurroundings() {
    return surroundings;
  }

  public void setSurroundings(Hashtable surroundings) {
    this.surroundings = surroundings;
  }

  public AbstractAppearance getAppearance() {
    return appearance;
  }

  public void setAppearance(AbstractAppearance appearance) {
    this.appearance = appearance;
  }

  public void addSense(AbstractSense sen, Object key) {
    this.senses.put(key,sen);
  }

  public AbstractSense getSense(Object key) {
    return (AbstractSense)this.senses.get(key);
  }

  public void addSurrounding(AbstractSurrounding sur, Object key) {
    this.surroundings.put(key,sur);
  }

  public AbstractSurrounding getSurrounding(Object key){
    return (AbstractSurrounding)this.surroundings.get(key);
  }

  public AbstractAttribute getAttribute(Object key) {
    return (AbstractAttribute)this.attributes.get(key);
  }

  public void addAttribute(Object key, AbstractAttribute att) {
    this.attributes.put(key, att);
  }

}
