package de.fish.tabacha.attributes;

import de.fish.tabacha.AbstractAttribute;

/** Weight attribute for things or else
    <br>$Id: Weight.java,v 1.2 2002/02/12 23:09:50 sva00-michael Exp $
    @author ?
    @author $Author: sva00-michael $
    @version $Revision: 1.2 $
*/
public class Weight extends AbstractAttribute implements Comparable
{
    private long gram;

    public Weight() {
      gram=0;
    }

    public String getName() {
      return ("Gewicht");
    }

    /**
	@param weight in gram
    */
    public long getValue() {
      return gram;
    }
    /**
	@param weight in gramm
    */
    public Weight(long weight)
    {
      gram=weight;
    }

    public long toGram() {
      return gram;
    }

    public long toPound() {
	return gram / 500;
    }

    public long toKilo() {
      return (gram / 1000);
    }

    public long toStones(long gewichtInStein) {
      return gram / 850;
    }


    /** Zaehlt zu dem de.fish.tabacha.attributes.Weight ein zweites de.fish.tabacha.attributes.Weight und gibt die Summe zurueck
	@param summand de.fish.tabacha.attributes.Weight (zweiter Summand)
	@return Ergebnis der Addition
    */
    public Weight sum(Weight w) {
      return new Weight(gram+w.toGram());
    }

    /** Zieht von dem de.fish.tabacha.attributes.Weight ein zweites de.fish.tabacha.attributes.Weight ab und
	gibt die Differenz zurueck
	@param summand de.fish.tabacha.attributes.Weight (zweiter Summand)
	@return Ergebnis der Addition
    */
    public Weight differenz(Weight w)
    {
	return new Weight(gram-w.toGram());
    }

    public Weight getWeigthMultiplied(int factor) {
      return new Weight(gram*factor);
    }

    /** Gibt das de.fish.tabacha.attributes.Weight als Zeichenkette  zurueck
	@return de.fish.tabacha.attributes.Weight als Zeichenkette z.B. 7 kG 200g */
   public String toString() {
     // XXX Hier muss noch was hin
     return (new Long(gram)).toString().concat(new String("g"));
 }

  public boolean equals(Object obj) {
    return gram==((Weight)obj).toGram();
  }


  public int compareTo(Object obj) {
    return 0;
   }
}
