package de.fish.tabacha.client;

/**
 * ServerCommandsOut
 *
 * Created: Jul 24, 2001 1:43:55 PM
 *
 * @author Holger <Holger@tabacha.de>
 * @version $Revision: 1.2 $
 */
public class ClientCommandsOut {
	// Constants -----------------------------------------------------
    static final char CH_LOGIN =    'P';
	static final char CH_LOGOUT =   'G';
	static final char CH_USESKILL = 'S';
	static final char CH_TALK = 	'T';
	static final char CH_REFRESH =  'R';
	static final char CH_ANSWER = 	'A';
	static final char CH_ITEM = 	'I';
	static final char CH_FIELD = 	'F';



	// Attributes ----------------------------------------------------

	// Static --------------------------------------------------------
	/**
	 * specify name and password to log into server
	 */
	public static String login(String name, String password)
	  {
		  return (CH_LOGIN+name+","+password);
	  }
	/**
	 * logout
	 */
	public static String logout()
	  {
		  return (String.valueOf(CH_LOGOUT));
	  }

	/**
	 * use skill on item
	 */
	public static String useSkillOnItem(int skill, int item)
	  {

		  return (CH_USESKILL+Integer.toString(skill)+CH_ITEM+Integer.toString(item));
	  }
	/**
	 * use skill on several items
	 */
		public static String useSkillOnItems(int skill, int item, int number)
	  {

		  return (CH_USESKILL+Integer.toString(skill)+CH_ITEM+Integer.toString(item)+
		          ","+Integer.toString(number));
	  }
	/**
	 * use skill on field
	 */
	public static String useSkillOnField(int skill, int x, int y)
	  {
		  return (CH_USESKILL+Integer.toString(skill)+
			      CH_FIELD+Integer.toString(x)+","+Integer.toString(y));
	  }
	/**
	 * talk a text
	 */
	public static String talk(String text)
	  {
		  return (CH_TALK+text);
	  }
  	// Constructors --------------------------------------------------
		
	// Public --------------------------------------------------------
     public static void main(String[] args) {
         // Welcome to the main-method
         System.out.println(login("Holger","geheim"));
		 System.out.println(useSkillOnField(1,1,0));
		 System.out.println(useSkillOnItem(2,3));
		 System.out.println(useSkillOnItems(2,3,52));
		 System.out.println(logout());
     }
	// Z implementation ----------------------------------------------

	// Y overrides ---------------------------------------------------

	// Package protected ---------------------------------------------

	// Protected -----------------------------------------------------

	// Private -------------------------------------------------------

	// Inner classes -------------------------------------------------

} // ServerCommandsOut

/*
 * Local variables:
 *  compile-command: "ant -emacs -find"
 * End:
 */
