package de.fish.tabacha.client;

/**
 * Vom TabachaDatagramClient zum Server
 *
 * a..e seien Zahlen. s sei ein String (mit Lngenangabe oder durch ein besonderes Zeichen abgeschlossen).
 * SaFb
 *          Benutze Fhigkeit Nr. a auf das Feld b. (S=Skill)
 * SaGc
 *            Benutze Fhigkeit Nr. a auf den Gegenstand c.
 *  SaGc,d
 *            Benutze Fhigkeit Nr. a auf d Exemplare des Gegenstands c. (Ein Gegenstand ist stets aus dem Inventar des
 *            Charakters. Der dritte Fall ist wichtig fr Befehle wie: Lege 74 Goldstcke auf den Tisch, damit nicht 74 Befehle
 *            gesendet werden mssen.)
 * R<String>
 *            Rede <String>
 * L
 *            Lade die Daten (Karte und Inventar) neu. Holger ist der Meinung, da dieser Befehl nicht ntig ist.
 * Ae[,...]
 *            Antworte auf die Anfrage mit der ID e und bergib die darauffolgenden Parameter. (Art und Anzahl der Parameter
 *            hngen von der Art der Anfrage ab.)
 *            W
 *
   <br>$Id: TabachaDatagramClient.java,v 1.1 2002/02/12 23:09:50 sva00-michael Exp $
   @author Holger <Holger@tabacha.de>
   @author $Author: sva00-michael $
   @version $Revision: 1.1 $
 */

  import java.io.*;
  import java.net.*;
  import java.util.*;

public class TabachaDatagramClient {
	// Constants -----------------------------------------------------

	// Attributes ----------------------------------------------------

	// Static --------------------------------------------------------
 
	// Constructors --------------------------------------------------
		
	// Public --------------------------------------------------------
         public static void main(String[] args) throws IOException {

        if (args.length != 1) {
             System.out.println("Usage: javade.fish.tabachaClient <hostname>");
             return;
        }

            // get a datagram socket
        DatagramSocket socket = new DatagramSocket();

            // send request
        byte[] buf = new byte[256];
        InetAddress address = InetAddress.getByName(args[0]);
        DatagramPacket packet = new DatagramPacket(buf, buf.length, address, 4445);
        socket.send(packet);

            // get response
        packet = new DatagramPacket(buf, buf.length);
        socket.receive(packet);

            // display response
        String received = new String(packet.getData());
        System.out.println("Quote of the Moment: " + received);

        socket.close();
    }
	// Z implementation ----------------------------------------------

	// Y overrides ---------------------------------------------------

	// Package protected ---------------------------------------------

	// Protected -----------------------------------------------------

	// Private -------------------------------------------------------

	// Inner classes -------------------------------------------------

} //de.fish.tabachaClient

/*
 * Local variables:
 *  compile-command: "ant -emacs -find"
 * End:
 */
