package de.fish.tabacha.server;

import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;

/**
 * MapShow
 *
 * Created: Jul 19, 2001 11:14:27 AM
 *
 * @author nils <nils@teha-systems.de>
 * @version $Revision: 1.2 $
 */
public class MapTile {
	// Constants -----------------------------------------------------

	// Attributes ----------------------------------------------------
     protected String name;
	 protected int xSize;
	 protected int ySize;
 	 protected FileInputStream fileInputStream;
     protected File file;
     protected int[][] map;

	// Static --------------------------------------------------------
 
	// Constructors --------------------------------------------------

	public MapTile (int xS,int yS)
	{
		initialize(xS,yS);
	}

	public MapTile (int[][] field, int xS, int yS)
		{

			this.xSize=xS;
			this.ySize=yS;
			this.map=field;

		}

	public MapTile (MapTile source, int xS, int yS, int xAt, int yAt)
	{

		this.xSize=xS;
		this.ySize=yS;
		map=source.getField(xS,yS,xAt,yAt);

	}
	/**
	 * construct based upon oldde.fish.tabacha-files size 30*30
	 * offset 8 byte for 4 surrounding maps.
	 */
	public MapTile (File aFile) throws IOException
	{
		// initialize Attributes
		initialize(30,30);
        this.file = aFile;
		this.name = aFile.getName();

        this.fileInputStream = new FileInputStream(file);

		// Skip 8 bytes (surrounding maps)
		fileInputStream.skip(8);

		// read File
		System.out.println("Bytes: "+fileInputStream.available());
        for (int i=0;i<this.xSize*this.ySize;i++)
		{
			map[i / xSize][i % ySize] = fileInputStream.read()+256*fileInputStream.read();
		}
	}
	// Public --------------------------------------------------------

	/**
	 * set x,y size and initialize internal map
	 */
	public void initialize(int xS,int yS)
	{
		this.xSize=xS;
		this.ySize=yS;
		map = new int [this.xSize][this.ySize];
	}

	public String getName()
	{
		 return this.name;
	 }
    /**
	 * get horizontal size of maptile
	 */
	public int getXSize()
	{
		return this.xSize;
	}
	/**
	 * get vertical size of maptile
	 */
	public int getYSize()
	{
		return this.ySize;
	}
	//get int at position x,y
	public int getInt(int x, int y)
	{
		return map[x][y];
	}


	// get field of size xS,yS at position xAt,yAt (left upper corner)
	public int[][] getField(int xS,int yS, int xAt, int yAt)
	{
		int[][] aField = new int[xS][yS];
        for (int ix=0;ix<xS;ix++) {
		for (int iy=0;iy<yS;iy++)
		{
			aField[ix][iy]=map[xAt+ix][yAt+iy];
		}
		}
		return aField;
	}
	// Z implementation ----------------------------------------------



	// Y overrides ---------------------------------------------------

	// Package protected ---------------------------------------------

	// Protected -----------------------------------------------------

	// Private -------------------------------------------------------

	// Inner classes -------------------------------------------------

} // MapShow

/*
 * Local variables:
 *  compile-command: "ant -emacs -find"
 * End:
 */
