package de.fish.tabacha.server;

import java.io.*;
import java.net.*;
import java.util.*;


/**
 * TabachaServerThread
 *
 * <br> $Id: TabachaServerThread.java,v 1.3 2002/02/12 23:09:50 sva00-michael Exp $
 *
 * @author Holger <holger@tabacha.de>
 * @version $Revision: 1.3 $
 */
public class TabachaServerThread
    extends Thread
{
	// Constants -----------------------------------------------------

	// Attributes ----------------------------------------------------
	protected DatagramSocket socket = null;
	   protected BufferedReader in = null;
	   protected boolean moreQuotes = true;


	// Static --------------------------------------------------------
 
	// Constructors --------------------------------------------------
    public TabachaServerThread() throws IOException {
        this("TabachaServerThread");
    }

    public TabachaServerThread(String name) throws IOException {
        super(name);
        socket = new DatagramSocket(4445);

        try {
            in = new BufferedReader(new FileReader("/home/htewis/uni"));
        } catch (FileNotFoundException e) {
            System.err.println("Could not open quote file. Serving time instead.");
        }
    }
	// Public --------------------------------------------------------
      public void run() {

        while (moreQuotes) {
            try {
                byte[] buf = new byte[256];

                    // receive request
                DatagramPacket packet = new DatagramPacket(buf, buf.length);
                socket.receive(packet);

                    // figure out response
                String dString = null;
                if (in == null)
                    dString = new Date().toString();
                else
                    dString = getNextQuote();
                buf = dString.getBytes();

                    // send the response to the client at "address" and "port"
                InetAddress address = packet.getAddress();
                int port = packet.getPort();
                packet = new DatagramPacket(buf, buf.length, address, port);
                socket.send(packet);
            } catch (IOException e) {
                e.printStackTrace();
                moreQuotes = false;
            }
        }
        socket.close();
    }

    protected String getNextQuote() {
        String returnValue = null;
        try {
            if ((returnValue = in.readLine()) == null) {
                in.close();
                moreQuotes = false;
                returnValue = "No more quotes. Goodbye.";
            }
        } catch (IOException e) {
            returnValue = "IOException occurred in server.";
        }
        return returnValue;
    }

	// Z implementation ----------------------------------------------

	// Y overrides ---------------------------------------------------

	// Package protected ---------------------------------------------

	// Protected -----------------------------------------------------

	// Private -------------------------------------------------------

	// Inner classes -------------------------------------------------

} // TabachaServerThread

/*
 * Local variables:
 *  compile-command: "ant -emacs -find"
 * End:
 */
