/*
 * superclass of all spaces
 * User: Holger
 * Date: 28.04.2002
 * Time: 10:27:00
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package de.fish.tabacha.spaces;

import de.fish.tabacha.Thing;
import de.fish.tabacha.AbstractCoordinate;
import de.fish.tabacha.AbstractSurrounding;
import de.fish.tabacha.AbstractSense;

public abstract class AbstractSpace {
  public AbstractSpace() {

  }

  public abstract boolean addThing(Thing thing, AbstractCoordinate position);

  public abstract boolean removeThing(Thing thing, AbstractCoordinate position);

  public abstract boolean moveThing(Thing thing, AbstractCoordinate position);

  /** returns surrounding if thing has appropriate sense.
   *
   */
  public abstract AbstractSurrounding getSurrounding(AbstractSense sen, Thing thi);

  /** get coordinate of thing.
   * returns null if Thing is not in this space.
   * @param thi the thing
   */
  public abstract AbstractCoordinate getCoordinate(Thing thi);

  /** Get all things on a Coordinate. */
  public abstract Thing[] getThings (AbstractCoordinate coo);

  /** e.g. if a thing changes position the space gets
   * an event and has to tell all concerned surroundings
    */
  public abstract void receiveThingEvent();

}
