package de.fish.tabacha.test;

import java.io.*;


/** Tool to create .xml & .arc files to describe an object/archetype.
   <br> $Id: ConvertArch.java,v 1.1 2002/07/22 14:25:11 sva00-michael Exp $
   @author michael@tabacha.de
   @author $Author: sva00-michael $
   @version $Revision: 1.1 $
*/
public class ConvertArch
{

    /** Main method.
	Parameters are the image file names.
    */
    public static void main(String[] args)
    {
	for (int i=0; i<args.length; i++)
	    createArch(args[i]);
    }

    /** Creates arch files for one object.
	@param filename Name of the image file with full path.
    */
    public static void createArch(String filename)
    {
	System.out.print("image file: " + filename);
	
	int number = FilenameHelper.retrieveNumber(filename);
	String basename = FilenameHelper.cutSuffix(filename);
	Arch arch = new Arch(number);
	try
	    {
		System.out.print("  writing as XML...");
		PrintWriter xml = new PrintWriter(new FileOutputStream(basename + ".xml"));
		xml.print(arch.asXML());
		xml.close();
		System.out.println("  writing as Arc...");
		PrintWriter arc = new PrintWriter(new FileOutputStream(basename + ".arc"));
		arc.print(arch.asArc());
		arc.close();
	    }
	catch (FileNotFoundException exc)
	    { exc.printStackTrace(); }
    }
       
}
