package de.fish.tabacha.test;

import java.io.*;


/** Converts old style map files to xml files and crossfire map files.
   <br> $Id: ConvertMaps.java,v 1.1 2002/07/22 14:25:11 sva00-michael Exp $
   @author michael@tabacha.de
   @author $Author: sva00-michael $
   @version $Revision: 1.1 $
*/
public class ConvertMaps
{

    /** Main method.
	Parameters are the map file names.
    */
    public static void main(String[] args)
    {
	for (int i=0; i<args.length; i++)
	    convertMap(args[i]);
    }

    /** Creates xml file and crossfire map file for a map.
	@param filenam Name of the map file.
    */
    public static void convertMap(String filename)
    {
	System.out.print("map file: " + filename);

	try
	    {
		int number = FilenameHelper.retrieveNumber(filename);
		String basename = FilenameHelper.cutSuffix(filename);
		Map map = new Map(filename);

		System.out.print("  writing as XML...");
		PrintWriter xml = new PrintWriter(new FileOutputStream(basename + ".xml"));
		xml.print(map.asXML());
		xml.close();
		System.out.println("  writing as crossfire map file...");
		PrintWriter cfmap = new PrintWriter(new FileOutputStream(basename));
		cfmap.print(map.toCrossfire());
		cfmap.close();
	    }
	catch (IOException exc)
	    { exc.printStackTrace(); }
	
    }
    
}
