package de.fish.tabacha.test;

import de.fish.tools.DoublebufferedPanel;
import de.fish.tabacha.test.Map;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;


/** TabachaSwing
    <br>$Id: TabachaSwing.java,v 1.3 2002/07/22 14:25:11 sva00-michael Exp $
    @author nils <nils@teha-systems.de>
    @author $Author: sva00-michael $
    @version $Revision: 1.3 $
*/
public class TabachaSwing
{

    // Constants -----------------------------------------------------

    // Attributes ----------------------------------------------------
    Image picture;
    ImageIcon myIcon;
    String imageLocation = "/home/mk/fish/cvs/images";
    JFrame frame;
    JPanel myPanel;
    JPanel buttonPanel;
    DoublebufferedPanel bufferedPanel;
    Map leiguaMap;
    ImageIcon bigField;
    int theX, theY;
    
    // Static --------------------------------------------------------
 
    // Constructors --------------------------------------------------

    public TabachaSwing()
    {
	theX=10; theY=10;

	frame = new JFrame();
	frame.getContentPane().setLayout(new BorderLayout());

	JButton nButton = new JButton("North");
	JButton sButton = new JButton("South");
	JButton wButton = new JButton("West");
	JButton eButton = new JButton("East");
	nButton.setMnemonic('n');
	sButton.setMnemonic('s');
	wButton.setMnemonic('w');
	eButton.setMnemonic('e');

	nButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theY--;
		    showMap();
		    frame.repaint();
		}
	    });
	sButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theY++;
		    showMap();
		    frame.repaint();
		}
	    });
	wButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theX--;
		    showMap();
		    frame.repaint();
		}
	    });
	eButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theX++;
		    showMap();
		    frame.repaint();
		}
	    });

	JButton chooseMapButton = new JButton("new map");
	chooseMapButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent ae)
		{
		    JFileChooser mapChooser = new JFileChooser();
		    /*
		      ExampleFileFilter filter = new ExampleFileFilter();
		      filter.addExtension("map");
		      filter.setDescription("Tabacha maps");
		      chooser.setFileFilter(filter);
		    */
		    int returnVal = mapChooser.showOpenDialog(frame);
		    if(returnVal == JFileChooser.APPROVE_OPTION)
			{
			    try
				{
				    leiguaMap = new Map(mapChooser.getSelectedFile());
				    frame.setTitle(leiguaMap.getName());
				    showMap();
				}
			    catch (IOException ex)
				{ System.err.println("ERROR: "+ex); }
			}
		}
	    });
	

        myPanel = new JPanel();

	JTextField enterImageLocation = new JTextField(imageLocation);
	enterImageLocation.addActionListener(new ActionListener()
	    {
		public void actionPerformed(ActionEvent ae)
		{ imageLocation = ae.getActionCommand(); }
	    });

	bufferedPanel = new DoublebufferedPanel(360,315);
		
        buttonPanel= new JPanel();
	buttonPanel.setLayout(new BorderLayout());
	buttonPanel.add(nButton, BorderLayout.NORTH);
        buttonPanel.add(sButton, BorderLayout.SOUTH);
	buttonPanel.add(wButton, BorderLayout.WEST);
	buttonPanel.add(eButton, BorderLayout.EAST);
	buttonPanel.add(chooseMapButton, BorderLayout.CENTER);

	myPanel.setBorder(BorderFactory.createEmptyBorder(
							  10, //top
							  10, //left
							  10, //bottom
							  10) //right
			  );

        myPanel.setLayout(new BorderLayout());

	myPanel.add(enterImageLocation, BorderLayout.SOUTH);
	myPanel.add(buttonPanel,BorderLayout.NORTH);
	myPanel.add(bufferedPanel,BorderLayout.CENTER);
	frame.getContentPane().add(myPanel);

	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	frame.pack();
	frame.getContentPane().setSize(100,100);
    }


    // Public --------------------------------------------------------
    
    public void showMap()
    {
	System.out.println(theX+", "+theY);
	if (leiguaMap == null) return;
	int [][] myField=leiguaMap.getSubfield(theX, theY, theX+8, theY+8);
	for (int x=0;x<9; x++)
	    for (int y=0;y<9; y++)
		{
		    myIcon = new ImageIcon(imageLocation + "/" + (myField[x][y])+".GIF");
		    bufferedPanel.getHiddenGraphics().
			drawImage(myIcon.getImage(), x*40, y*35, null);
		}
    }

	// Z implementation ----------------------------------------------

	// Y overrides ---------------------------------------------------

	// Package protected ---------------------------------------------

	// Protected -----------------------------------------------------

	// Private -------------------------------------------------------

	// Inner classes -------------------------------------------------

}

/*
 * Local variables:
 *  compile-command: "ant -emacs -find"
 * End:
 */
