package de.fish.tabacha.test;

import java.lang.ClassLoader;
import java.lang.Class;


/** Das Mainprogramm zum Testen von Classen.
<PRE>
    Erfordert:
      - eine zu testende Klasse            z.B.de.fish.tabacha/paket/Klasse.class
      - einen Test der zu testenden Klasse 
        diese muss vonde.fish.tabacha.test
        abgeleitet sein und folgender 
        Namenskonvention entsprechen
        Der Klassenname ist der Klassenname
        der zu testenden Klassen mit dem 
        vorgestellten Wort "Test". Er liegt 
        im gleichen Verzeichniss           z.B.de.fish.tabacha/paket/TestKlasse.class
    Aufruf:
      java [param]de.fish.tabacha.Teste zu-testende-Klasse
                                           z.B. javade.fish.tabacha.Testede.fish.tabacha.paket.Klasse
</PRE>
    <P> $Id: Teste.java,v 1.1 2002/02/26 23:38:58 sva00-michael Exp $
    @see de.fish.tabacha.Test
    @author ?
    @author $Author: sva00-michael $
    @version $Revision: 1.1 $
*/      
public class Teste {
    /** Das Hauptprogramm.
	Laedt die TestKlasse und ruft die Methode runTest() auf.
        Aufruf: java [param]de.fish.tabacha.Teste zu-testende-Klasse
	@param args Wird von java Uebergeben und enthaelt die 
	zu-testende-Klasse also z.B.de.fish.tabacha.paket.Klasse
	@see de.fish.tabacha.Test
    */
    public static void main(String args[]) {
	if (args.length>0) {
	    try {
		// Beispiel:de.fish.tabacha.paket.Klasse
		String Klasse=args[0];
		// Beispiel:de.fish.tabacha.paket.TestKlasse
		String TestKlasse;
		int i=0;
		// Finde den letzten Punk im Namen
		for(i=Klasse.length();Klasse.charAt(i-1)!='.';i--) {
		}

		TestKlasse=Klasse.substring(0,i).concat("Test").concat(Klasse.substring(i));
		Class c= java.lang.Class.forName(TestKlasse);
		// System.out.println(c.getName());
		Test t=(Test)c.newInstance();
		t.printAnfang(Klasse);
		t.runTest();
		t.printZusammenfassung();
	    }
	    catch(java.lang.ClassNotFoundException cnfe) {
		System.out.print("Fehler: Klasse ");
		System.out.print(cnfe.getMessage());
		System.out.println(" nicht gefunden!");
	    }
	    catch(java.lang.Exception e){
		System.out.println("Fehler:");
		System.out.println(e);
	    }
	    
	} else {
	    System.out.println("Keine Klasse angegeben!");
	}
    }
}





